struct MethodResult
{
  double res;
  int count;
  double alpha;

  MethodResult():res(0),count(0),alpha(0) {}
  MethodResult(double r,int i,double a):res(r),count(i),alpha(a) {}
};

struct Alpha{
  double R;
  double alpha;

  Alpha(double r,double a):R(r),alpha(a) {}
};

typedef double (*MathFunc) (Alpha alpha);
typedef MethodResult (*Method) (double A,double B,double Ey,double R,MathFunc func);

MethodResult gold_method (double A,double B,double Ey,double R,MathFunc func );
MethodResult divide_method (double A,double B,double Ey,double R, MathFunc func);
double M(double q,double sigma,double H,double gamma,Alpha a);